#include <iostream>
#include <fstream>
#include <string>
using namespace std;

class image {
  public : 
    char **im;
    int  nbcol;
    int nblig;
    int nbgris;

   image(){
     im=NULL; nbcol=0; nblig=0; nbgris=0;
   };

    void affiche(void) const {
      int i ; int j;
      cout << "P5\n";
      cout << nbcol << " " << nblig << "\n";
      cout << nbgris << "\n";

      for (i=0 ; i<nbcol ; i++) {
        for (j=0 ; j<nblig ; j++) {
          cout << im[i][j];
          //cout << (int) ((unsigned char)im[i][j]) << " ";
        }
      }
    };

   void instance(bool positive) const {
     int i,j;
     if (positive) 
	cout << "1 ";
     else 
	cout << "-1 ";
     
      for (i=0 ; i<nbcol ; i++) {
        for (j=0 ; j<nblig ; j++) {
          cout << num(i,j) << ":" << (int) ((unsigned char)im[i][j]) << " ";
        }
      }
      cout << endl;
   };

   private:
     int num (const int i, const int j) const {
	return (i*nblig+j)+1;
     }

};

int getImage(fstream &fd, image &im) {
   string format;
   int i,j;
   
   fd >> format;
   if (format != "P5") throw -4;

   fd >> im.nbcol;
   fd >> im.nblig;


   fd >> im.nbgris;

   if (im.nbgris > 255 ) throw -4 ;

   im.im=new char *[im.nbcol];
   if (im.im==NULL) throw -5;
   for (i=0 ; i<im.nbcol ; i++) {
     im.im[i]=new char[im.nblig];
     if (im.im[i]==NULL) throw -5;
   }

   for (i=0 ; i<im.nbcol ; i++) {
     for (j=0 ; j<im.nblig ; j++) {
	im.im[i][j]=fd.get();
	if (fd.eof()) throw -6;
     }
   }
}

int main(int argc, char *argv[]) {
  try {
    if (argc<3) throw -1;
    string nomfichier=argv[1]; // le nom est assez explicite je crois
    string strclasse;
    strclasse.insert(0,argv[2]);
    bool classe; // la classe de l'instance 
    if ((strclasse=="p") || (strclasse=="pos")) {
	classe=true;
    }
    else if ((strclasse=="n") || (strclasse=="neg")) {
	classe=false;
    }
    else {
        throw -2;
    }

    fstream fd;
    fd.open(nomfichier.c_str() , fstream::in | fstream::binary);
    if (! fd.is_open()) throw -3;

    image im;

    getImage(fd,im);

    im.instance(classe);

    return 0;

  }
  catch (int erreur) {
    cout << "\nERREUR : ";
    switch (erreur) {
      case -1 :
        cout << "Utilisation " << argv[0] << " fichier pos/neg" << endl;
	break;
      case -2 :
        cout << "Utilisation " << argv[0] << " fichier pos/neg" << endl;
	cout << "crivez p ou pos ou n ou neg, exemple : " << endl;
	cout << argv[0] << " toto.pgm p" << endl;
	break;
      case -3 :
        cout << "impossible d'ouvrir le fichier " << argv[1] << endl;
	break;
      case -4 :
        cout << "mauvais format de fichier !" << endl;
	break;
      case -5 : 
	cout << "Impossible d'allouer la mmoire !" << endl;
	break;
      case -6 :
	cout << "Le fichier semble tronqu !" << endl;
	break;
      default :
	cout << "Erreur numero : " << erreur << endl;
    }
    return erreur;
  }
}

